
var curRenderParam = ''
/**
 *----------bridge通信--------
*/   
eventManager.addEventListener('BRIDGE_READY',function(){
    //通知客户端 bridge连接成功
    nativeBridge.callHandler('bridgeConnect');
    // writeLog(1,'bridgeConnect');
    //通知js端 渲染题目
    nativeBridge.registerHandler('renderQuestion', function(data, response){
        // writeLog(2,'renderQuestion');
        var renderData = stringTojson(data);
        renderData.questionData = JSON.stringify(renderData.questionData).replace(/&#39;/g, "'");
        var quesData = stringTojson(renderData.questionData);
        curRenderParam = renderData;
        if(renderData.userData != undefined){
            var userData = inputData(renderData.userData,quesData);
            $('#paperMain').attr('data', JSON.stringify(userData));
        }
        try {
            if (renderData) {
                response({
                    state: 'success',
                    queId: stringTojson(renderData.questionData).queId,
                    time: +new Date()
                })
            } else {
                response({
                    state: 'error',
                    data: '数据错误'
                })
            }
        } catch (error) {
            response({
                state: 'error',
                data: '数据错误'
            })
        }
        renderQuesTpl(renderData);
    })
    //通知js端 开始提交
    nativeBridge.registerHandler('startSubmit', function(){
        // open loading
        $('.submitBtn').addClass('loading');
    })
    //通知js端 技术提交
    nativeBridge.registerHandler('endSubmit', function(){
        // 关闭loading
        $('.submitBtn').removeClass('loading');
    })
    //重置dom，1.关闭音视频
    nativeBridge.registerHandler('resetHtml', function(data){
        // eventManager.removeEventListener('BRIDGE_READY');
        // 关闭音视频
        $('video').trigger('pause');
        $('audio').trigger('pause');
    })
    // 客户端获取用户作答数据
    nativeBridge.registerHandler('operationFeedback', function(resData, response){
        try {
            var _data = $('#paperMain').attr('data');
            if (_data) {
                var data = JSON.parse(_data);
                var quesData = stringTojson(curRenderParam.questionData);
                var judgeRes = getJudge(quesData,data);
                var extra = extraBlankData(judgeRes[0].judge, data)
                var userData = outputData(data,quesData);
                //发送作答反馈数据
                response({
                    state: 'success',
                    data: JSON.stringify({userData:userData,judgeData:judgeRes,extra:extra})
                })
            } else {
                // 用户无作答
                response({
                    state: 'success',
                    data: ''
                })
            }
        } catch (error) {
            // 报错
            response({
                state: 'error',
                data: error
            })
        }
    })
})
/**
 *----------业务渲染--------
*/
resetHtml();
if(!window.nativeBridge){
    // renderQuesTpl(
    //     {"type":"1","isSingle":false,"userData":"",
    //     "questionData":{"queId":"000969586ac1457a860549d41a230101","subjectName":"数学","subjectId":"2","gradeGroupName":"小学","gradeGroupId":"1","logicQuesTypeName":"单选","logicQuesTypeId":"1","writtenQuesTypeName":"选择","writtenQuesTypeId":"13f97b02f7e4f2c9d35ec1af3c2d1030","difficulty":1,"content":"<p>如图，$AB\\mathsf{\\text{\/\/}}CD$，$EF\\bot AB$于$E$，$EF$交$CD$于$F$，已知$\\angle 1=60{}^\\circ $，则$\\angle 2=$（&nbsp; ）．<\/p>\n<p style=\"text-align: right;\"><img alt=\"\" class=\"ggbImg\" data=\"https:\/\/tiku-fz-cdn.aibeike.com\/source\/tikufile\/paper\/tiku\/ggb_1520403997852.ggb\" height=\"158\" id=\"ggbImg1520403997852\" src=\"https:\/\/tiku-fz-cdn.aibeike.com\/source\/tikufile\/paper\/tiku\/ggbimg_1520403998306.png\" width=\"248\" \/><\/p>","answer":[["C"]],"analysis":["<p>$90{}^\\circ -60{}^\\circ =30{}^\\circ $．<\/p>\n<p>故选$\\text{C}$．<\/p>"],"queSource":null,"answerOptionList":[[{"aoVal":"A","content":"$20{}^\\circ $"},{"aoVal":"B","content":"$60{}^\\circ $"},{"aoVal":"C","content":"$30{}^\\circ $"},{"aoVal":"D","content":"$45{}^\\circ $"}]],"examOptionList":[{"id":"a8272cdbe4e8444196ea860027e2799d","name":"几何模块","lkcId":"0052e3948be741728b682819cd303753","childList":[{"childList":[{"childList":[{"childList":[{"childList":[],"id":"329cea263de14b7fa5a81b3c6762b63e","lkcId":"0052e3948be741728b682819cd303753","name":"角度的计算"}],"id":"58c7bf3625e9493b9d1416e929ae332d","lkcId":"0052e3948be741728b682819cd303753","name":"图形认知角"}],"id":"beba5449db0747cb809d7b4ed335a81b","lkcId":"0052e3948be741728b682819cd303753","name":"图形认知"}],"id":"e821a670dd424a20a11e17abc2b8e651","lkcId":"0052e3948be741728b682819cd303753","name":"直线型"}]}],"isCloze":0,"modifyDate":"2020-01-14 17:09:46","score":0,"queDesc":null,"normalAnswer":[["C"]],"blankAnswer":null,"blankInteraction":null,"isDecidable":1,"oneQuestionMoreAnalysisArr":["<p>$90{}^\\circ -60{}^\\circ =30{}^\\circ $．<\/p>\n<p>故选$\\text{C}$．<\/p>"],"answerType":0,"quePreviewURL":"https:\/\/yulan-fz.jiaoyanyun.com\/preview\/preview!previewQuestion.action?queId=000969586ac1457a860549d41a230101&subjectId=2&isTemporaryTable=0&appKey=5db5618912a5a0eec4c2783bbea8378f","childList":null,"isIntoAnswerTool":1,"keyboardType":0,"parasitismQue":null,"isPush":0,"isIntoClass":1,"eleRole":4},
    //     "isHideSubmit":false,
    //     "submitBottonText":"交题",
    //     "questionType":"选择题",
    //     "isDefaultSubmit":true}
    // )
    // var data = {
    //     type: 1,
    //     // userData: JSON.parse("[[\"\\\\overarc{\\\\triangle\\\\equiv\\\\subsetneqq}\\\\dot{\\\\varnothing}≌\"],[\"\"]]"),
    //     userData: JSON.parse("[[\"asd\"]]"),
    //     // userData: "B",
    //     // questionData:choice[2],
    //     // questionData:fillblank[3],
    //     questionData:JSON.stringify(test[0]),
    //     // isDefaultSubmit: true,
    //     isHideSubmit: false,
    //     // submitBottonText:'交题',
    //     questionType: '选择题'
    // }
    // renderQuesTpl(data)
}

$('body').on('touchstart','.submitBtn',function(){
    submitBtnClick($(this));
})

//渲染题版、渲染结果解析
function renderQuesTpl(renderParam){
    if(renderParam){
        if (renderParam.questionType) {
            $('#questionType').html(renderParam.questionType)
        } else {
            $('#questionType').hide()
            $('#questionArea').removeClass('padding-48')
        }
        curRenderParam = renderParam;
        var quesData = stringTojson(renderParam.questionData);
        //渲染题干
        $('#questionArea').html('').addClass('invisible');
        TalqsInteraction.setUserConfig({
            org: "peiyou",
            sys: "zaixianyingyuweilaiheiban",
            stuId: "xxx"
        })
        var _renderHtml = TalqsTemplate.render(quesData,{hideSource: true,hideDifficulty: true})
        $('#questionArea').html(_renderHtml)
        TalqsInteraction.initTqiQs();
        //底部区默认取消显示
        toggleBottomHeight(0);
        //作答状态下 初始化提交按钮
        if(renderParam.type == 1){
            $('#questionArea').removeClass('pisition-fixed').css('padding-bottom', '100px');
            $('#bottomMain').css('position', 'fixed');
            //隐藏键盘
            if(!renderParam.isHideSubmit){
                var text = renderParam.submitBottonText;
                if(text == '交题'){
                    $('.submitBtn').find('.s').html(text).show();
                    $('.submitBtn').find('.d').hide();
                }else{
                    $('.submitBtn').find('.s').hide();
                    $('.submitBtn').find('.d').show();
                    $('.submitBtn .gray-btn').hide();
                }
                //需要展示选择题样式键盘
                if(quesData.logicQuesTypeId==1 || quesData.logicQuesTypeId==2 || isSystemKeyBoard(quesData)){
                    toggleBottomHeight(1);
                }
                //处理默认状态的按钮是否需要置灰
                if(!renderParam.isDefaultSubmit){
                    $('.submitBtn').addClass('grey');
                    if (text != '交题') {
                        $('.submitBtn .gray-btn').show();
                        $('.submitBtn .normal-btn').hide();
                    } 
                }
            }
            toggleInteract(quesData,true);
        }
        //如果传过来userData则渲染作答结果
        if(renderParam.userData != undefined){
            var userData = inputData(renderParam.userData,quesData);
            if(renderParam.type == 2){//解析状态下 渲染判题结果
                var judgeData = getJudge(quesData,userData);
                TalqsInteraction.setData([{queId:quesData.queId,data:userData.data,result:judgeData[0].judge}]);
            }else{
                TalqsInteraction.setData([{queId:quesData.queId,data:userData.data}]);
                if(userData.data.join("")!=""){
                    $('.submitBtn').removeClass('grey');
                    if (renderParam.submitBottonText != '交题') {
                        $('.submitBtn .gray-btn').hide();
                        $('.submitBtn .normal-btn').show();
                    }
                }
            }
        }
        if(renderParam.type == 2){
            $('#questionArea').addClass('pisition-fixed').css('padding-bottom', '20px');
            $('#bottomMain').css('position', 'relative');
            var enterStr = ''
            var temp = ''
            var latexBlackArr = []
            if (userData.data.length > 0) {
                var _len = 0;
                var jud = judgeData[0].judge;
                for (var i = 0; i < jud.length; i++) {
                    if (userData.data[i]) {
                        if(jud[i] == 1){
                            latexBlackArr.push(userData.data[i])
                            enterStr += "<span class=\"talqs_panel_item\">".concat(i + 1, ". <span class=\"right papaer-latex-block\" latexId=").concat(i, "></span></span>").concat(i == userData.data.length - 1 ? '' : '；');
                        }else{
                            latexBlackArr.push(userData.data[i])
                            enterStr += "<span class=\"talqs_panel_item\">".concat(i + 1, ". <span class=\"wrong papaer-latex-block\" latexId=").concat(i, "></span></span>").concat(i == userData.data.length - 1 ? '' : '；');
                        }
                    } else {
                        enterStr += "<span class=\"talqs_panel_item\">".concat(i + 1, ". <span class=\"wrong\">").concat("未答", "</span></span>").concat(i == userData.data.length - 1 ? '' : '；');
                        _len++;
                    }
                }
                if (_len === userData.data.length) {
                    enterStr = "<div class=\"talqs_panel_item\">无作答数据</div>";
                }
            } else {
                enterStr = "<div class=\"talqs_panel_item\">无作答数据</div>";
            }
            temp = "<div class=\"talqs_keyword clearfix\"><label class=\"talqs_label\">我的答案</label><div class=\"paper-talqs_panel talqs_panel\" id=\"myAns\">".concat(enterStr, "</div></div>");
            TalqsTemplate.updateTemplateList({
                analyzeWrapper: {
                    exclude: ['questionID', 'questionKnowledgePoint'],
                    components: [{ // 添加试题标签到末尾
                        name: 'questionLabel',
                        template: temp,
                        index: 1
                    }]
                }
            })
            //渲染解析
            $('#jiexi').html('').addClass('invisible');
            $('#jiexi').html(
                TalqsTemplate.render(quesData, {analyzeVersion: 2,entryTemplate: TalqsTemplate.components.AnalyzeWrapper})
            )
            var _isSystemKeyBoard = isSystemKeyBoard(quesData);
            latexBlackArr.forEach(function(item, index) {
                if (_isSystemKeyBoard) {
                    $('.papaer-latex-block').eq(index).html(item)
                } else {
                    TalqsInteraction.latexToHtml($('.papaer-latex-block').eq(index)[0], [item]);
                }
            })
            toggleInteract(quesData,false);
            toggleBottomHeight(3);
        }
        TalqsTemplate.autoLayout();
        //文科题目直接展示
        if($.inArray(Number(quesData.subjectId),[1,3,8,9,10]) >- 1){
            $('#questionArea').removeClass('invisible');
            $('#jiexi').removeClass('invisible');
        }
        //回调后显示内容
        MathJax.Hub.Queue(['Typeset', MathJax.Hub,document.getElementById('paperMain')],function(){
            $('#questionArea').removeClass('invisible');
            $('#jiexi').removeClass('invisible');
            // 渲染完毕页面回调
            nativeBridge.callHandler('paperOnload', {
                state: 'success',
                time: +new Date()
            })
            //页面是否包含video或者audio标签
            nativeBridge.callHandler('isExistVideoOrAudio', !!($('video').length + $('audio').length));
        });
    }
}
//判断本题应弹系统键盘情况下 依然展示选择题类型的提交按钮
function isSystemKeyBoard(quesData){
    if(quesData.logicQuesTypeId == 4){
        var blankInfo = quesData.blankAnswer.answer[0];//用作客户输入类型判断
        if(Number(blankInfo.typeId)==1 && Number(blankInfo.childTypeId)!=(10006 && 10032)){
            var subjectIdArr = [1,3,8,9,10];//文科的学科id
            if($.inArray(Number(quesData.subjectId),subjectIdArr) >- 1){
                return true
            }
        }
    }
    return false;
}
/**
 * 获取判题结果，并上报客户端作答数据和判题数据
 * @return {array} 返回判题数据
 */
function getJudge(quesData,userData){
    var judgeRes = judge([{
        "queId": quesData.queId,
        "rigAnswer": quesData.normalAnswer || quesData.answer,
        "blankAnswer": quesData.blankAnswer,
        "type": quesData.logicQuesTypeId,
        "gradeGroupId": quesData.gradeGroupId,
        "subjectId": quesData.subjectId,
        "stuAnswer": userData.data,
        "halfRight": true,
        "content": ""
    }], {
        org: "peiyou",
        sys: "zaixianyingyuweilaiheiban",
        stuId: "xxx"
    });
    return judgeRes;
}

/**
 *----------教研sdk相关事件监听--------
*/
TalqsInteraction.onChange = function(data){
    //是否有效作答判断
    if(!curRenderParam.isDefaultSubmit){
        if(data.data.join("") != ""){
            $('.submitBtn').removeClass('grey');
            if (curRenderParam.submitBottonText != '交题') {
                $('.submitBtn .gray-btn').hide();
                $('.submitBtn .normal-btn').show();
            }
        }else{
            $('.submitBtn').addClass('grey');
            if (curRenderParam.submitBottonText != '交题') {
                $('.submitBtn .gray-btn').show();
                $('.submitBtn .normal-btn').hide();
            }
        }
    }
    $('#paperMain').attr('data', JSON.stringify(data));
    var quesData = stringTojson(curRenderParam.questionData);
    var userData = outputData(data,quesData);
    if (nativeBridge) {
        try {
            if (data.data.join("") !== "") {
                userCallHandle({
                    state: 'success',
                    data: {
                        isAnwserData: true,
                        data: data,
                        userData: userData,
                    }
                })
            } else {
                userCallHandle({
                    state: 'success',
                    data: {
                        isAnwserData: false,
                        data: data,
                        userData: userData,
                    }
                })
            }
        } catch (error) {
            userCallHandle({
                state: 'error',
                data: data,
                message: error
            })
        }
    }
};

// 安卓判断用户是否作答和作答数据上报
function userCallHandle(info) {
    if (nativeBridge) {
        nativeBridge.callHandler('userDataOnChange', JSON.stringify(info));
    }
}

//理科键盘
document.addEventListener('softkeyboard_show',function(){
    setTimeout(function(){
        toggleBottomHeight(2)
    }, 100)
    nativeBridge.callHandler('keyboardShow');
})
document.addEventListener('softkeyboard_hide',function(){
    var quesData = stringTojson(curRenderParam.questionData);
    setTimeout(function(){
        if(curRenderParam.type==1 && quesData.logicQuesTypeId!=1 && quesData.logicQuesTypeId!=2 && !isSystemKeyBoard(quesData)){
            toggleBottomHeight(0);
        }
    }, 100);
    nativeBridge.callHandler('keyboardHide');
})

//简单键盘
document.addEventListener('custom_keyboard_show',function(){
    toggleBottomHeight(2)
    nativeBridge.callHandler('keyboardShow');
})
document.addEventListener('custom_keyboard_hide',function(){
    setTimeout(function(){
        if(curRenderParam.type == 1){
            toggleBottomHeight(0)
        }
    }, 100);
    nativeBridge.callHandler('keyboardHide');
})


// 后台需要的字段格式
function pushData(index, score, data) {
    var answer = ''
    if (data && Object.prototype.toString.call(data.data) === "[object Array]") {
        answer = data.data[index]
    }
    return {
        "index" : index + 1, //第几个空
        "answer": answer, //空上学生填的答案
        "score": score, //空上的正误，确是100，错误是0分，-1表示未答；
    }
}
// 用户每个空的数据组装
function extraBlankData(judgeRes, data) {
    if (judgeRes && Object.prototype.toString.call(judgeRes) === "[object Array]") {
        var returnObj = [];
        for (var i = 0, l = judgeRes.length; i < l; i++) {
            if (judgeRes[i] === 1) {
                returnObj.push(pushData(i, 100, data))
            } else if (judgeRes[i] === -2) {
                returnObj.push(pushData(i, -1, data))
            } else {
                returnObj.push(pushData(i, 0, data))
            }
        }
        return returnObj
    }
    return [];
}

// 提交按钮点击
function submitBtnClick(btn){
    if(!btn.hasClass('loading') && !btn.hasClass('grey')){
        // writeLog(1,'triggerSubmit');
        nativeBridge.callHandler('triggerSubmit');
        nativeBridge.callHandler('keyboardHide');
    }
}
/**
 * 动态显示底部区域
 * @param {num} type  1选择题提交按钮  2键盘  3解析 不传则默认bottom高度0
 */
function toggleBottomHeight(type){
    if(type){
        switch (type) {
            //选择题底部提交
            case 1:
                $('#submitBtnBox').addClass('show');
                $('#keyboardArea').removeClass('show');
                $('#jiexi').removeClass('show');
                $('#bottomMain').height(100);
                break;
            //键盘底部
                case 2:
                if(curRenderParam.isHideSubmit){
                    $('#keyboardArea').addClass('hideBtn')
                }
                $('#submitBtnBox').removeClass('show');
                $('#keyboardArea').addClass('show');
                $('#jiexi').removeClass('show');
                $('#bottomMain').height(275);
                break;
            //解析底部
                case 3:
                $('#submitBtnBox').removeClass('show');
                $('#keyboardArea').removeClass('show');
                $('#jiexi').addClass('show');
                $('#bottomMain').height("45%");
                break;
        }
    }else{
        $('#submitBtnBox').removeClass('show');
        $('#keyboardArea').removeClass('show');
        $('#jiexi').removeClass('show');
        $('#bottomMain').height(0);
    }
}
function resetHtml(){
    var curRenderParam = null;//用来接收客户端穿过来的参数 用于渲染本道题目
    TalqsInteraction.initTqiQs();
    TalqsInteraction.keyPadContainer = document.getElementById('keyBox');
    TalqsInteraction.keyPadContainerHeight = 275
    TalqsInteraction.resetKeyboardState();
    TalqsInteraction.hideKeyboard();
    TalqsInteraction.hideFillKeyboard();
}

/**
 * 教研sdk部分
 */
//开关本道题的交互
function toggleInteract(originData,isOpen){
    var paramState = [];
    //打开传1  关闭传0
    if(originData.logicQuesTypeId == 1){//选择类型
        paramState.push(~~isOpen);
    }else{
        for(var i=0;i<originData.answer.length;i++){//填空类型
            paramState.push(~~isOpen);
        }
    }
    TalqsInteraction.toggleInteraction([{
        queId: originData.queId,
        rectifyState: paramState
    }])
}
function stringTojson(jsonString){
    if(typeof jsonString == 'string'){
        return JSON.parse(jsonString);
    }
    return jsonString;
}
/**
 * 输出后端需要的数据格式
 * @param {paper用户作答数据} data 
 * @param {题目数据} question 
 */
function outputData(data, question) {
    var returnData = ''
    // 选择题，单选和多选
    if (question.logicQuesTypeId == '1' || question.logicQuesTypeId == '2') {
        returnData = data.data.join(',')
    } else { // 填空题处理
        var _data = []
        data.data.forEach(function(item){
            _data.push([item])
        })
        returnData = JSON.stringify(_data)
    }
    console.log('组装数据：', returnData)
    return returnData
}
/**
 * 输入paper需要的数据格式
 * @param {后端返回用户数据} answer 
 * @param {题目数据} question 
 */
function inputData(answer, question) {
    var returnData = {
        queId: question.queId,
        rootId: question.queId,
        type: question.logicQuesTypeId
    }
    // 选择题，单选和多选
    if (question.logicQuesTypeId == '1' || question.logicQuesTypeId == '2') {
        returnData.data = answer.split(',')
    } else { // 填空题处理
        var _data = []
        if(answer) {
            stringTojson(answer).forEach(function(item){
                if (item[0].indexOf('&#39;') != -1) {
                    _data.push(item[0].replace('&#39;', "'"))
                } else {
                    _data.push(item[0])
                }
            })
        }
        returnData.data = _data
    }
    console.log('拆分数据：', returnData)
    return returnData
}

//兼容键盘收起后 页面不回弹
(/iphone|ipod|ipad/i.test(navigator.appVersion)) && document.addEventListener('blur', function(e){ 
    document.body.scrollIntoView(true)
}, true)

